Index: /waeup/branches/ulif-importers/src/waeup/browser/pages.py
===================================================================
--- /waeup/branches/ulif-importers/src/waeup/browser/pages.py	(revision 4842)
+++ /waeup/branches/ulif-importers/src/waeup/browser/pages.py	(revision 4843)
@@ -325,5 +325,5 @@
     grok.template('datacenterimport1page')
     grok.require('waeup.manageUniversity')
-    title = u'Import CSV file manually'
+    title = u'Process CSV file'
     pnav = 0
 
@@ -354,5 +354,5 @@
     grok.template('datacenterimport2page')
     grok.require('waeup.manageUniversity')
-    title = u'Import CSV file manually'
+    title = u'Process CSV file'
     pnav = 0
 
@@ -420,5 +420,5 @@
     grok.template('datacenterimport3page')
     grok.require('waeup.manageUniversity')
-    title = u'Import CSV file manually'
+    title = u'Process CSV file'
     pnav = 0
 
@@ -514,5 +514,5 @@
     grok.template('datacenterimport4page')
     grok.require('waeup.manageUniversity')
-    title = u'Import CSV file manually'
+    title = u'Process CSV file'
     pnav = 0
 
Index: /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport1page.pt
===================================================================
--- /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport1page.pt	(revision 4842)
+++ /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport1page.pt	(revision 4843)
@@ -1,7 +1,10 @@
-<h2>Manual import</h2>
+<h2>Process CSV file</h2>
 <h3>Step 1</h3>
-
 <p>
-  Please select a file for import from the list below
+  Using batch processing you can mass-create, mass-update, or
+  mass-remove datasets from the database using CSV files.
+</p>
+<p>
+  Please select a file for processing from the list below
 </p>
 <form method="POST">
Index: /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport2page.pt
===================================================================
--- /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport2page.pt	(revision 4842)
+++ /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport2page.pt	(revision 4843)
@@ -1,3 +1,3 @@
-<h2>Manual import</h2>
+<h2>Process CSV file</h2>
 <h3>Step 2</h3>
 
@@ -9,5 +9,6 @@
   </p>
   <p>
-    Please select an importer and an import mode from the selections below:
+    Please select a file-processor and a processing-mode from the 
+    selections below:
   </p>
 
@@ -41,5 +42,5 @@
 
   <div>
-    Importer:
+    <b>Processor:</b>
 
     <select name="importer">
@@ -57,5 +58,5 @@
 
   <div>
-    Mode:
+    <b>Mode:</b>
 
     <input type="radio" name="mode" value="create" checked="checked"
Index: /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport3page.pt
===================================================================
--- /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport3page.pt	(revision 4842)
+++ /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport3page.pt	(revision 4843)
@@ -1,3 +1,3 @@
-<h2>Manual import</h2>
+<h2>Process CSV file</h2>
 <h3>Step 3</h3>
 <div tal:define="warnings view/getWarnings">
@@ -14,5 +14,5 @@
   </p>
   <p>
-    <b>Importer:</b>
+    <b>Processor:</b>
     <span tal:content="view/importer/name">Importer Name</span>
     <input type="hidden" name="importer"
@@ -20,5 +20,5 @@
   </p>
   <p>
-    <b>Import mode: </b>
+    <b>Processing mode: </b>
     <span tal:content="view/mode">mode</span>
     <input type="hidden" name="mode"
Index: /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport4page.pt
===================================================================
--- /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport4page.pt	(revision 4842)
+++ /waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport4page.pt	(revision 4843)
@@ -1,3 +1,3 @@
-<h2>Manual import</h2>
+<h2>Process CSV file</h2>
 <h3>Step 4</h3>
 <p>
@@ -8,9 +8,9 @@
 </p>
 <p>
-  <b>Importer:</b>
+  <b>Processor:</b>
   <span tal:content="view/importer/name">Importer Name</span>
 </p>
 <p>
-  <b>Import mode: </b>
+  <b>Processing mode: </b>
   <span tal:content="view/mode">mode</span>
 </p>