Index: /WAeUP_SRP/trunk/skins/waeup_futminna/getAccommodationInfo.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/getAccommodationInfo.py	(revision 4860)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/getAccommodationInfo.py	(revision 4861)
@@ -16,5 +16,5 @@
 import DateTime
 
-booking_disabled = True
+booking_disabled = False
 
 request = context.REQUEST
Index: /WAeUP_SRP/trunk/skins/waeup_futminna/getSchoolFee.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/getSchoolFee.py	(revision 4860)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/getSchoolFee.py	(revision 4861)
@@ -29,7 +29,7 @@
             d['all'] = 72700    
         elif brain.lga == 'foreigner':
-            d['all'] = 131500 + 5000
+            d['all'] = 131500 #+ 5000
         else:
-            d['all'] = 41500 + 5000
+            d['all'] = 41500 #+ 5000
     # returning
     elif brain.review_state == 'returning':
@@ -39,5 +39,5 @@
             d['all'] = 109500
         else:
-            d['all'] = 19500 + 5000
+            d['all'] = 19500 #+ 5000
     else:
         d['all'] = 0
Index: /WAeUP_SRP/trunk/skins/waeup_futminna/pay_interswitch.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/pay_interswitch.py	(revision 4860)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/pay_interswitch.py	(revision 4861)
@@ -1,3 +1,3 @@
-## Script (Python) "pay_online"
+## Script (Python) "pay_interswitch"
 ##bind container=container
 ##bind context=context
@@ -50,6 +50,22 @@
 info['site_id'] = '117'
 info['currency_id'] = '566'
-pay_item_id = "11700"
-
+
+if student_record.mode in ('pg_ft'):
+    pay_item_id = "11703"
+elif student_record.review_state == 'cleared_and_validated' and student_record.level in ('100'):
+    pay_item_id = "11700"
+elif student_record.review_state == 'cleared_and_validated' and student_record.level in ('200'):
+    pay_item_id = "11701"    
+elif student_record.review_state == 'returning' and student_record.level in ('100'):
+    pay_item_id = "11701"
+elif student_record.review_state == 'returning' and student_record.level in ('200'):
+    pay_item_id = "11702"
+elif student_record.review_state == 'returning' and student_record.level in ('300'):
+    pay_item_id = "11703"
+elif student_record.review_state == 'returning' and student_record.level in ('400','500'):
+    pay_item_id = "11704"
+else:
+    pay_item_id = ""
+    
 info['bank'] = ''
 info['payment_possible'] = True
@@ -72,7 +88,8 @@
 
 
-info['surcharge'] = interswitch_amount = '300'
+info['surcharge'] = 0  # students don't have to pay the surcharge, FUT is paying for them
+interswitch_amount = 300
 info['amount'] = amount = fee_dict['all']
-total_amount = 100*int(amount) + 100*int(interswitch_amount)
+total_amount = 100*int(amount) 
 
 
@@ -127,5 +144,5 @@
 bt_amount = 1500
 #fut_split = 0000 #not appicable
-fut_amount = amount - bt_amount 
+fut_amount = amount - bt_amount - interswitch_amount
 
 xmldict = {}
@@ -139,31 +156,33 @@
 
 #students at all levels pay their school fees to different banks
-if student_record.review_state == 'cleared_and_validated' and student_record.level in ('100'):
-    if student_record.mode == 'jm_ft':
-        xmldict['fut_acct'] = "0030001000016190"
-        xmldict['bank_id'] = '89'
-    else:
-        xmldict['fut_acct'] = "0510031193719"
-        xmldict['bank_id'] = '75' 
+
+if student_record.mode == 'jm_ft':
+    xmldict['fut_acct'] = "000000000000"
+    xmldict['bank_id'] = '0'
+elif student_record.mode in ('pg_ft'):
+    xmldict['fut_acct'] = "2522040000134"
+    xmldict['bank_id'] = '8'
+elif student_record.review_state == 'cleared_and_validated' and student_record.level in ('100'):
+    xmldict['fut_acct'] = "0030001000017110"
+    xmldict['bank_id'] = '89' 
+elif student_record.review_state == 'cleared_and_validated' and student_record.level in ('200'):
+    xmldict['fut_acct'] = "0591201005146"
+    xmldict['bank_id'] = '101'
 elif student_record.review_state == 'returning' and student_record.level in ('100'):    
-    if student_record.mode == 'jm_ft':
-        xmldict['fut_acct'] = "0030001000016190"
-        xmldict['bank_id'] = '89'        
-    else:
-        xmldict['fut_acct'] = "0030001000017110"
-        xmldict['bank_id'] = '89' 
+    xmldict['fut_acct'] = "0591201005146"
+    xmldict['bank_id'] = '101' 
 elif student_record.level in ('200'):
+    xmldict['fut_acct'] = "6013803345"
+    xmldict['bank_id'] = '117'  
+elif student_record.level in ('300'):
     xmldict['fut_acct'] = "2522040000134"
     xmldict['bank_id'] = '8'  
-elif student_record.level in ('300','400'):
-    xmldict['fut_acct'] = "0591201005146"
-    xmldict['bank_id'] = '101'  
-elif student_record.level in ('500'):
-    xmldict['fut_acct'] = "0030001000017110"
-    xmldict['bank_id'] = '89'    
+elif student_record.level in ('400','500'):
+    xmldict['fut_acct'] = "02530040000664"
+    xmldict['bank_id'] = '7'    
 #remedial students
-elif student_record.level in ('000'):
-    xmldict['fut_acct'] = "6013803183"
-    xmldict['bank_id'] = '117'     
+#elif student_record.level in ('000'):
+    #xmldict['fut_acct'] = "00000000000"
+    #xmldict['bank_id'] = '0'     
 else:
     xmldict['fut_acct'] = "0000000000000"
@@ -191,3 +210,2 @@
 
 return context.goto_interswitch_form(info=info)
-
Index: /WAeUP_SRP/trunk/skins/waeup_futminna/payments_view.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/payments_view.pt	(revision 4860)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/payments_view.pt	(revision 4861)
@@ -74,5 +74,5 @@
                    />
             <br /><br />
-            <font color='red'>Surcharge for Late Registration of non-remedial students is 5000 Naira. </font>
+            <font tal:condition="python:False" color='red'>Surcharge for Late Registration of non-remedial students is 5000 Naira. </font>
           </form>  
           <form tal:condition="python: info.get('payment_method') == 'sc_payment'" 