Index: /waeup/branches/ulif-namespace/src/waeup/sirp/authentication.txt
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/authentication.txt	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/authentication.txt	(revision 4921)
@@ -12,5 +12,5 @@
 Before we can check access we have to create an app:
 
-  >>> from waeup.app import University
+  >>> from waeup.sirp.app import University
   >>> root = getRootFolder()
   >>> u = University()
@@ -36,5 +36,5 @@
 user credentials and some metadata persistently:
 
-  >>> from waeup.authentication import Account
+  >>> from waeup.sirp.authentication import Account
   >>> alice = Account('alice', 'alicesecret')
   >>> root['app']['users'].addAccount(alice)
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser.txt
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser.txt	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser.txt	(revision 4921)
@@ -25,5 +25,5 @@
   []
 
-  >>> from waeup.app import University
+  >>> from waeup.sirp.app import University
   >>> u = University()
   >>> root['myuniversity'] = u
@@ -265,5 +265,5 @@
 Courses are stored in :class:`ICourseContainer` instances with their
 code as key. CourseContainers are normally availabe as `course`
-attribute of :class:`waeup.university.department.Department`
+attribute of :class:`waeup.sirp.university.department.Department`
 instances.
 
@@ -413,5 +413,5 @@
 with their code as key. CertificateContainers are normally availabe as
 `certificates` attribute of
-:class:`waeup.university.department.Department` instances.
+:class:`waeup.sirp.university.department.Department` instances.
 
 To ease the life of users we do not require to browse the
@@ -725,5 +725,5 @@
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   ...
-  <b>Storage path:</b> <span>/.../waeup/files</span>
+  <b>Storage path:</b> <span>/.../waeup/sirp/files</span>
   ...
 
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/batchprocessing.txt
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/batchprocessing.txt	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/batchprocessing.txt	(revision 4921)
@@ -23,5 +23,5 @@
 Create a site:
 
-    >>> from waeup.app import University
+    >>> from waeup.sirp.app import University
     >>> getRootFolder()['app'] = University()
 
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/breadcrumbs.txt
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/breadcrumbs.txt	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/breadcrumbs.txt	(revision 4921)
@@ -13,5 +13,5 @@
 We create a university to check the breadcrumb functionality.
 
-    >>> from waeup.app import University
+    >>> from waeup.sirp.app import University
     >>> root = getRootFolder()
     >>> root['app'] = University()
@@ -24,8 +24,8 @@
 viewname:
 
-    >>> from waeup.browser.breadcrumbs import getBreadcrumbList
+    >>> from waeup.sirp.browser.breadcrumbs import getBreadcrumbList
     >>> blist1 = getBreadcrumbList(app, 'index')
     >>> blist1
-    [<waeup.browser.breadcrumbs.UniversityBreadcrumb object at 0x...>]
+    [<waeup.sirp.browser.breadcrumbs.UniversityBreadcrumb object at 0x...>]
 
 A slightly more extensive list for the datacenter:
@@ -34,7 +34,7 @@
     >>> from pprint import pprint
     >>> pprint(blist2)
-    [<waeup.browser.breadcrumbs.UniversityBreadcrumb object at 0x...>,
-     <waeup.browser.breadcrumbs.AdministrationBreadcrumb object at 0x...>,
-     <waeup.browser.breadcrumbs.DataCenterBreadcrumb object at 0x...>]
+    [<waeup.sirp.browser.breadcrumbs.UniversityBreadcrumb object at 0x...>,
+     <waeup.sirp.browser.breadcrumbs.AdministrationBreadcrumb object at 0x...>,
+     <waeup.sirp.browser.breadcrumbs.DataCenterBreadcrumb object at 0x...>]
 
 We get a breadcrumb for university, administration area and data
@@ -49,7 +49,7 @@
 
      >>> pprint([(x.context, x.viewname) for x in blist2])
-     [(<waeup.app.University object at 0x...>, 'index'),
-      (<waeup.app.University object at 0x...>, 'administration'),
-      (<waeup.datacenter.DataCenter object at 0x...>, 'index')]
+     [(<waeup.sirp.app.University object at 0x...>, 'index'),
+      (<waeup.sirp.app.University object at 0x...>, 'administration'),
+      (<waeup.sirp.datacenter.DataCenter object at 0x...>, 'index')]
 
 The administration area breadcrumb might be a surprise, as there is no
@@ -91,5 +91,5 @@
 Now we can get the breadcrumbs for this view:
 
-    >>> from waeup.browser.breadcrumbs import getBreadcrumbListForView
+    >>> from waeup.sirp.browser.breadcrumbs import getBreadcrumbListForView
     >>> blist3 = getBreadcrumbListForView(page)
     >>> [x.title for x in blist3]
@@ -111,5 +111,5 @@
 The returned breadcrumb container supports iteration:
 
-    >>> from waeup.browser.interfaces import IBreadcrumbContainer
+    >>> from waeup.sirp.browser.interfaces import IBreadcrumbContainer
     >>> mybccontainer = IBreadcrumbContainer(page)
     >>> [x.title for x in mybccontainer]
@@ -133,8 +133,8 @@
 
     >>> from zope.component import getAdapter
-    >>> from waeup.browser.interfaces import IBreadcrumb
+    >>> from waeup.sirp.browser.interfaces import IBreadcrumb
     >>> b1 = getAdapter(app, IBreadcrumb, 'index')
     >>> b1
-    <waeup.browser.breadcrumbs.UniversityBreadcrumb object at 0x...>
+    <waeup.sirp.browser.breadcrumbs.UniversityBreadcrumb object at 0x...>
 
 Breadcrumb objects provide a title:
@@ -158,5 +158,5 @@
     >>> b2 = getAdapter(app['datacenter'], IBreadcrumb, 'index')
     >>> b2
-    <waeup.browser.breadcrumbs.DataCenterBreadcrumb object at 0x...>
+    <waeup.sirp.browser.breadcrumbs.DataCenterBreadcrumb object at 0x...>
 
     >>> b2.title
@@ -170,5 +170,5 @@
 
     >>> b2.parent
-    (<waeup.app.University object at 0x...>, 'administration')
+    (<waeup.sirp.app.University object at 0x...>, 'administration')
 
 This result denotes a new context object (the University instance we
@@ -186,5 +186,5 @@
     >>> b3 = getAdapter(context, IBreadcrumb, viewname)
     >>> b3
-    <waeup...breadcrumbs.AdministrationBreadcrumb object at 0x...>
+    <waeup.sirp...breadcrumbs.AdministrationBreadcrumb object at 0x...>
 
 As you can see, we get an AdministrationBreadcrumb, although the
@@ -199,5 +199,5 @@
     >>> context, viewname = b3.parent
     >>> context, viewname
-    (<waeup.app.University object at 0x...>, 'index')
+    (<waeup.sirp.app.University object at 0x...>, 'index')
 
 We create last breadcrumb:
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/ftesting.zcml
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/ftesting.zcml	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/ftesting.zcml	(revision 4921)
@@ -1,10 +1,10 @@
 <configure
    xmlns="http://namespaces.zope.org/zope"
-   i18n_domain="waeup"
-   package="waeup"
+   i18n_domain="waeup.sirp"
+   package="waeup.sirp"
    >
 
   <include package="grok" />
-  <include package="waeup" />
+  <include package="waeup.sirp" />
 
   <!-- Typical functional testing security setup -->
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/courserefs.txt
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/courserefs.txt	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/courserefs.txt	(revision 4921)
@@ -18,5 +18,5 @@
 As correct deletion of references needs support of catalogs (we lookup
 catalogs to find references), we need a fully blown ZODB here,
-including an instance of :class:`waeup.app.University`, as this is our
+including an instance of :class:`waeup.sirp.app.University`, as this is our
 `ISite` object where the catalogs are stored.
 
@@ -25,5 +25,5 @@
 and course certificates:
 
-    >>> from waeup.app import University
+    >>> from waeup.sirp.app import University
     >>> root = getRootFolder()
     >>> root['app'] = University()
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/utils/batching.txt
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/utils/batching.txt	(revision 4920)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/utils/batching.txt	(revision 4921)
@@ -1,4 +1,4 @@
-:mod:`waeup.utils.batching` -- Batch processing
-***********************************************
+:mod:`waeup.sirp.utils.batching` -- Batch processing
+****************************************************
 
 Batch processing is much more than pure data import.
@@ -190,5 +190,5 @@
 All we need, is a batch processor now.
 
-    >>> from waeup.utils.batching import BatchProcessor
+    >>> from waeup.sirp.utils.batching import BatchProcessor
     >>> class CaveProcessor(BatchProcessor):
     ...   util_name = 'caveprocessor'