Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/batchprocessing.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/batchprocessing.txt	(revision 4992)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/batchprocessing.txt	(revision 4993)
@@ -284,7 +284,7 @@
 
     >>> open('certificates.csv', 'wb').write(
-    ... """code,faculty_code,department_code,title,category,study_mode,start_level,end_level,max_pass,application_category
-    ... CERT1,FAC1,DEP1,Certificate 1,UG,uf_ft,100,500,30,basic
-    ... CERT2,FAC1,DEP1,Certificate 2,UG,uf_ft,200,400,30,cest
+    ... """code,faculty_code,department_code,title,study_mode,start_level,end_level,max_pass,application_category
+    ... CERT1,FAC1,DEP1,Certificate 1,uf_ft,100,500,30,basic
+    ... CERT2,FAC1,DEP1,Certificate 2,uf_ft,200,400,30,cest
     ... """)
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 4992)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 4993)
@@ -441,5 +441,4 @@
 Set the remaining required fields:
 
-  >>> browser.getControl(name='form.category').value = 'UME'
   >>> browser.getControl(name='form.study_mode').value = 'combined'
   >>> browser.getControl(name='form.start_level').value = '100'
@@ -459,5 +458,4 @@
   >>> ctrl.value = 'Another cert with same code'
   >>> browser.getControl(name='form.code').value = 'CERT1'
-  >>> browser.getControl(name='form.category').value = 'UME'
   >>> browser.getControl(name='form.study_mode').value = 'combined'
   >>> browser.getControl(name='form.start_level').value = '100'
@@ -581,5 +579,4 @@
   >>> browser.getControl(name='form.code').value = 'CERT1'
   >>> browser.getControl(name='form.title').value = 'Certificate 1'
-  >>> browser.getControl(name='form.category').value = 'UME'
   >>> browser.getControl(name='form.study_mode').value = 'combined'
   >>> browser.getControl(name='form.start_level').value = '100'
@@ -594,5 +591,4 @@
   >>> browser.getControl(name='form.code').value = 'CERT2'
   >>> browser.getControl(name='form.title').value = 'Certificate 2'
-  >>> browser.getControl(name='form.category').value = 'UME'
   >>> browser.getControl(name='form.study_mode').value = 'combined'
   >>> browser.getControl(name='form.start_level').value = '100'
@@ -837,5 +833,5 @@
 
   >>> open('certificates.csv', 'wb').write(
-  ... """code,title,faculty_code,department_code,category,study_mode,end_level,m_prefix,max_pass,start_level,application_category,review_state
+  ... """code,title,faculty_code,department_code,study_mode,end_level,m_prefix,max_pass,start_level,application_category,review_state
   ... LBA,BACHELOR OF LITERATURE,FA,LIT,UG,ug_ft,500,LIT,30,100,basic,checked
   ... LMA,MASTER OF LITERATURE,FA,LIT,UG,ug_pt,500,LIT,30,100,cest,checked
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/certificatepage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/certificatepage.pt	(revision 4992)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/certificatepage.pt	(revision 4993)
@@ -18,8 +18,4 @@
     </tr>
     <tr class="odd">
-      <td>Application Category:</td>
-      <td tal:content="context/category">CATEGORY</td>
-    </tr>
-    <tr class="even">
       <td>Study Mode:</td>
       <td tal:content="context/study_mode">STUDY_MODE</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 4992)
+++ main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 4993)
@@ -217,8 +217,4 @@
         )
 
-    category = schema.TextLine(
-        title = u'category',
-        )
-
     study_mode = schema.TextLine(
         title = u'study mode',
@@ -238,9 +234,10 @@
     application_category = schema.TextLine(
         title = u'application category',
-        required = True,
+        required = False,
         )
     
     max_pass = schema.TextLine(
         title = u'maximum pass',
+        required = False,
         )
     
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py	(revision 4992)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py	(revision 4993)
@@ -15,10 +15,9 @@
 
     def __init__(self, code=u'NA', title=u'Unnamed Certificate',
-                 category=None, study_mode=None, start_level=None,
+                 study_mode=None, start_level=None,
                  end_level=None, application_category=None, max_pass = u''):
         super(Certificate, self).__init__()
         self.code = code
         self.title = title
-        self.category = category
         self.study_mode = study_mode
         self.start_level = start_level
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.txt	(revision 4992)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.txt	(revision 4993)
@@ -23,5 +23,5 @@
 --------------------
 
-.. class:: Certificate([code=u'NA',[ title=u'Unnamed Certificate',[ category=None,[ study_mode=None,[ start_level=None,[ end_level=None,[ application_category=None,[ m_prefix=u'',[  max_pass = u'']]]]]]]]])
+.. class:: Certificate([code=u'NA',[ title=u'Unnamed Certificate',[ study_mode=None,[ start_level=None,[ end_level=None,[ application_category=None,[ m_prefix=u'',[  max_pass = u'']]]]]]]])
 
    Create a certificate object with the given parameters.
@@ -77,12 +77,4 @@
          :meth:`Certificate.check` -- mark a certificate as ``checked``
 
-   .. attribute:: category
-
-      Each :class:`Certificate` instance has a category:
-
-        >>> print mycertificate.category
-        None
-
-      .. XXX: This is not a proper description
 
    .. attribute:: study_mode