Index: /main/waeup.sirp/trunk/src/waeup/sirp/datacenter.txt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/datacenter.txt	(revision 4998)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/datacenter.txt	(revision 4999)
@@ -143,10 +143,10 @@
     ...  'mysource.csv', create_pending=False)
     >>> mydatacenter.distProcessedFiles(True, src, finished_src,
-    ...                            pending_src)
+    ...                            pending_src, mode='create')
     >>> sorted(os.listdir(dc_root))
     ['finished', 'logs', 'unfinished']
 
     >>> sorted(os.listdir(fin_dir))
-    ['mysource.csv', 'mysource.finished.csv']
+    ['mysource.create.finished.csv', 'mysource.csv']
 
     >>> sorted(os.listdir(unfin_dir))
@@ -168,10 +168,10 @@
     ...  'mysource.csv')
     >>> mydatacenter.distProcessedFiles(False, src, finished_src,
-    ...                                 pending_src)
-    >>> sorted(os.listdir(dc_root))
-    ['finished', 'logs', 'mysource.pending.csv', 'unfinished']
-
-    >>> sorted(os.listdir(fin_dir))
-    ['mysource.finished.csv']
+    ...                                 pending_src, mode='create')
+    >>> sorted(os.listdir(dc_root))
+    ['finished', 'logs', 'mysource.create.pending.csv', 'unfinished']
+
+    >>> sorted(os.listdir(fin_dir))
+    ['mysource.create.finished.csv']
 
     >>> sorted(os.listdir(unfin_dir))
@@ -186,7 +186,7 @@
 
     >>> tmp_dir, src, finished_src, pending_src = create_fake_results(
-    ...  'mysource.pending.csv', create_pending=False)
+    ...  'mysource.create.pending.csv', create_pending=False)
     >>> mydatacenter.distProcessedFiles(True, src, finished_src,
-    ...                                 pending_src)
+    ...                                 pending_src, mode='create')
 
     >>> sorted(os.listdir(dc_root))
@@ -194,5 +194,5 @@
 
     >>> sorted(os.listdir(fin_dir))
-    ['mysource.csv', 'mysource.finished.csv']
+    ['mysource.create.finished.csv', 'mysource.csv']
 
     >>> sorted(os.listdir(unfin_dir))
@@ -210,25 +210,25 @@
     ...  'mysource.csv')
     >>> mydatacenter.distProcessedFiles(False, src, finished_src,
-    ...                                 pending_src)
+    ...                                 pending_src, mode='create')
 
 We try to process the pending file, which fails again:
 
     >>> tmp_dir, src, finished_src, pending_src = create_fake_results(
-    ...  'mysource.pending.csv')
-    >>> mydatacenter.distProcessedFiles(False, src, finished_src,
-    ...                                 pending_src)
+    ...  'mysource.create.pending.csv')
+    >>> mydatacenter.distProcessedFiles(False, src, finished_src,
+    ...                                 pending_src, mode='create')
 
 We try to process the new pending file:
 
     >>> tmp_dir, src, finished_src, pending_src = create_fake_results(
-    ...  'mysource.pending.csv')
-    >>> mydatacenter.distProcessedFiles(False, src, finished_src,
-    ...                                 pending_src)
-
-    >>> sorted(os.listdir(dc_root))
-    ['finished', 'logs', 'mysource.pending.csv', 'unfinished']
-
-    >>> sorted(os.listdir(fin_dir))
-    ['mysource.finished.csv']
+    ...  'mysource.create.pending.csv')
+    >>> mydatacenter.distProcessedFiles(False, src, finished_src,
+    ...                                 pending_src, mode='create')
+
+    >>> sorted(os.listdir(dc_root))
+    ['finished', 'logs', 'mysource.create.pending.csv', 'unfinished']
+
+    >>> sorted(os.listdir(fin_dir))
+    ['mysource.create.finished.csv']
 
     >>> sorted(os.listdir(unfin_dir))
@@ -238,7 +238,7 @@
 
     >>> tmp_dir, src, finished_src, pending_src = create_fake_results(
-    ...  'mysource.pending.csv', create_pending=False)
+    ...  'mysource.create.pending.csv', create_pending=False)
     >>> mydatacenter.distProcessedFiles(True, src, finished_src,
-    ...                                 pending_src)
+    ...                                 pending_src, mode='create')
 
     >>> sorted(os.listdir(dc_root))
@@ -246,5 +246,5 @@
 
     >>> sorted(os.listdir(fin_dir))
-    ['mysource.csv', 'mysource.finished.csv']
+    ['mysource.create.finished.csv', 'mysource.csv']
 
     >>> sorted(os.listdir(unfin_dir))