Index: main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py	(revision 5005)
@@ -7,5 +7,6 @@
 from zope.component.interfaces import IFactory, ComponentLookupError
 from zope.interface import implementedBy
-from waeup.sirp.interfaces import ICertificate, ICertificateCourse, ICourse
+from waeup.sirp.university.interfaces import (
+    ICertificate, ICertificateCourse, ICourse)
 
 class Certificate(grok.Container):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.txt	(revision 5005)
@@ -36,5 +36,5 @@
    Certificates have the attributes required by the `ICertificate` interface:
 
-     >>> from waeup.sirp.interfaces import ICertificate
+     >>> from waeup.sirp.university.interfaces import ICertificate
      >>> ICertificate.providedBy(mycertificate)
      True
@@ -323,5 +323,5 @@
 :class:`ICertificateCourse` interface:
 
-    >>> from waeup.sirp.interfaces import ICertificateCourse
+    >>> from waeup.sirp.university.interfaces import ICertificateCourse
     >>> from waeup.sirp.university.certificate import CertificateCourse
     >>> mycertcourse = CertificateCourse(None, 200, False)
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/certificatecontainer.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/certificatecontainer.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/certificatecontainer.py	(revision 5005)
@@ -2,5 +2,6 @@
 """
 import grok
-from waeup.sirp.interfaces import ICertificateContainer, ICertificate
+from waeup.sirp.university.interfaces import (
+    ICertificateContainer, ICertificate)
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/certificatecontainer.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/certificatecontainer.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/certificatecontainer.txt	(revision 5005)
@@ -41,5 +41,5 @@
    Certificate containers provide `ICertificateContainer`:
 
-     >>> from waeup.sirp.interfaces import ICertificateContainer
+     >>> from waeup.sirp.university.interfaces import ICertificateContainer
      >>> ICertificateContainer.providedBy(mycontainer)
      True
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/course.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/course.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/course.py	(revision 5005)
@@ -4,5 +4,5 @@
 from zope.interface import implementedBy
 from zope.component.interfaces import IFactory
-from waeup.sirp.interfaces import ICourse
+from waeup.sirp.university.interfaces import ICourse
 
 class Course(grok.Model):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/course.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/course.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/course.txt	(revision 5005)
@@ -38,5 +38,5 @@
    :class:`waeup.sirp.interfaces.ICourse` interface:
 
-     >>> from waeup.sirp.interfaces import ICourse
+     >>> from waeup.sirp.university.interfaces import ICourse
      >>> ICourse.providedBy(mycourse)
      True
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/coursecontainer.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/coursecontainer.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/coursecontainer.py	(revision 5005)
@@ -4,5 +4,5 @@
 from zope.interface import implementedBy
 from zope.component.interfaces import IFactory
-from waeup.sirp.interfaces import ICourseContainer, ICourse
+from waeup.sirp.university.interfaces import ICourseContainer, ICourse
 
 class CourseContainer(grok.Container):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/coursecontainer.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/coursecontainer.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/coursecontainer.txt	(revision 5005)
@@ -41,5 +41,5 @@
    Course containers provide `ICourseContainer`:
 
-     >>> from waeup.sirp.interfaces import ICourseContainer
+     >>> from waeup.sirp.university.interfaces import ICourseContainer
      >>> ICourseContainer.providedBy(mycontainer)
      True
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/department.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/department.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/department.py	(revision 5005)
@@ -5,5 +5,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.sirp.interfaces import IDepartment
+from waeup.sirp.university.interfaces import IDepartment
 
 class Department(grok.Container):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/department.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/department.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/department.txt	(revision 5005)
@@ -43,5 +43,5 @@
    `IDepartment` interface:
 
-     >>> from waeup.sirp.interfaces import IDepartment
+     >>> from waeup.sirp.university.interfaces import IDepartment
      >>> IDepartment.providedBy(mydept)
      True
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/faculty.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/faculty.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/faculty.py	(revision 5005)
@@ -5,5 +5,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.sirp.interfaces import IFaculty, IDepartment
+from waeup.sirp.university.interfaces import IFaculty, IDepartment
 
 class Faculty(grok.Container):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/faculty.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/faculty.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/faculty.txt	(revision 5005)
@@ -42,5 +42,5 @@
    `IFaculty` interface:
 
-     >>> from waeup.sirp.interfaces import IFaculty
+     >>> from waeup.sirp.university.interfaces import IFaculty
      >>> IFaculty.providedBy(myfac)
      True
@@ -175,5 +175,5 @@
 Faculties have the attributes required by the `IFaculty` interface:
 
-    >>> from waeup.sirp.interfaces import IFaculty
+    >>> from waeup.sirp.university.interfaces import IFaculty
     >>> IFaculty.providedBy(myfaculty)
     True
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/facultycontainer.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/facultycontainer.py	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/facultycontainer.py	(revision 5005)
@@ -2,5 +2,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.sirp.interfaces import IFacultyContainer, IFaculty
+from waeup.sirp.university.interfaces import IFacultyContainer, IFaculty
 
 class FacultyContainer(grok.Container):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/facultycontainer.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/facultycontainer.txt	(revision 5004)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/facultycontainer.txt	(revision 5005)
@@ -43,5 +43,5 @@
    `IFacultyContainer` interface:
 
-     >>> from waeup.sirp.interfaces import IFacultyContainer
+     >>> from waeup.sirp.university.interfaces import IFacultyContainer
      >>> IFacultyContainer.providedBy(mycontainer)
      True
@@ -129,5 +129,5 @@
 Faculty containers provide `IFacultyContainer`:
 
-    >>> from waeup.sirp.interfaces import IFacultyContainer
+    >>> from waeup.sirp.university.interfaces import IFacultyContainer
     >>> IFacultyContainer.providedBy(mycontainer)
     True